#!/bin/bash

PATH=$PATH:/usr/bin

cd /etc/kamailio/ssl

# generate private key
echo generating private key
openssl genrsa -out server.key 1024

# generate certificate request
echo generating certificate request
openssl req -new -key server.key -out server.csr -subj '/CN=pbx.wildix.com/O=WILDIX SRL/C=IT/emailAddress=support@wildix.com'

# create self-signed certificate
echo generating certificate
openssl x509 -req -days 7650 -in server.csr -signkey server.key -out server.crt

chown wms:wms server.key
chmod go-rwx server.key

chown wms:wms server.crt
chmod go-rwx server.crt
