BEGIN TRANSACTION;
CREATE TABLE version (
    table_name VARCHAR(32) NOT NULL,
    table_version INT UNSIGNED DEFAULT 0 NOT NULL
);
INSERT INTO "version" VALUES('acc',4);
INSERT INTO "version" VALUES('missed_calls',3);
INSERT INTO "version" VALUES('dbaliases',1);
INSERT INTO "version" VALUES('subscriber',7);
INSERT INTO "version" VALUES('usr_preferences',2);
INSERT INTO "version" VALUES('carrierroute',3);
INSERT INTO "version" VALUES('carrierfailureroute',2);
INSERT INTO "version" VALUES('carrier_name',1);
INSERT INTO "version" VALUES('domain_name',1);
INSERT INTO "version" VALUES('cpl',1);
INSERT INTO "version" VALUES('dialog',4);
INSERT INTO "version" VALUES('dialplan',1);
INSERT INTO "version" VALUES('dispatcher',3);
INSERT INTO "version" VALUES('domain',1);
INSERT INTO "version" VALUES('domainpolicy',2);
INSERT INTO "version" VALUES('grp',2);
INSERT INTO "version" VALUES('re_grp',1);
INSERT INTO "version" VALUES('htable',1);
INSERT INTO "version" VALUES('imc_rooms',1);
INSERT INTO "version" VALUES('imc_members',1);
INSERT INTO "version" VALUES('gw',10);
INSERT INTO "version" VALUES('lcr',3);
INSERT INTO "version" VALUES('silo',8);
INSERT INTO "version" VALUES('pdt',1);
INSERT INTO "version" VALUES('trusted',6);
INSERT INTO "version" VALUES('address',3);
INSERT INTO "version" VALUES('pua',6);
INSERT INTO "version" VALUES('purplemap',1);
INSERT INTO "version" VALUES('aliases',8);
INSERT INTO "version" VALUES('rls_presentity',0);
INSERT INTO "version" VALUES('rls_watchers',1);
INSERT INTO "version" VALUES('sip_trace',4);
INSERT INTO "version" VALUES('speed_dial',2);
INSERT INTO "version" VALUES('uri',1);
INSERT INTO "version" VALUES('userblacklist',1);
INSERT INTO "version" VALUES('globalblacklist',1);
CREATE TABLE acc (
    id INTEGER PRIMARY KEY NOT NULL,
    method VARCHAR(16) DEFAULT '' NOT NULL,
    from_tag VARCHAR(64) DEFAULT '' NOT NULL,
    to_tag VARCHAR(64) DEFAULT '' NOT NULL,
    callid VARCHAR(64) DEFAULT '' NOT NULL,
    sip_code VARCHAR(3) DEFAULT '' NOT NULL,
    sip_reason VARCHAR(32) DEFAULT '' NOT NULL,
    time DATETIME NOT NULL
);
CREATE TABLE missed_calls (
    id INTEGER PRIMARY KEY NOT NULL,
    method VARCHAR(16) DEFAULT '' NOT NULL,
    from_tag VARCHAR(64) DEFAULT '' NOT NULL,
    to_tag VARCHAR(64) DEFAULT '' NOT NULL,
    callid VARCHAR(64) DEFAULT '' NOT NULL,
    sip_code VARCHAR(3) DEFAULT '' NOT NULL,
    sip_reason VARCHAR(32) DEFAULT '' NOT NULL,
    time DATETIME NOT NULL
);
CREATE TABLE dbaliases (
    id INTEGER PRIMARY KEY NOT NULL,
    alias_username VARCHAR(64) DEFAULT '' NOT NULL,
    alias_domain VARCHAR(64) DEFAULT '' NOT NULL,
    username VARCHAR(64) DEFAULT '' NOT NULL,
    domain VARCHAR(64) DEFAULT '' NOT NULL,
    CONSTRAINT alias_idx UNIQUE (alias_username, alias_domain)
);
CREATE TABLE subscriber (
    id INTEGER PRIMARY KEY NOT NULL,
    username VARCHAR(64) DEFAULT '' NOT NULL,
    domain VARCHAR(64) DEFAULT '' NOT NULL,
    password VARCHAR(64) DEFAULT '' NOT NULL,
    ha1 VARCHAR(128) DEFAULT '' NOT NULL,
    ha1b VARCHAR(128) DEFAULT '' NOT NULL,
    email_address VARCHAR(128) DEFAULT NULL,
    rpid VARCHAR(128) DEFAULT NULL,
    CONSTRAINT subscriber_account_idx UNIQUE (username, domain)
);
CREATE TABLE usr_preferences (
    id INTEGER PRIMARY KEY NOT NULL,
    uuid VARCHAR(64) DEFAULT '' NOT NULL,
    username VARCHAR(128) DEFAULT 0 NOT NULL,
    domain VARCHAR(64) DEFAULT '' NOT NULL,
    attribute VARCHAR(32) DEFAULT '' NOT NULL,
    type INT DEFAULT 0 NOT NULL,
    value VARCHAR(128) DEFAULT '' NOT NULL,
    last_modified DATETIME DEFAULT '1900-01-01 00:00:01' NOT NULL
);
CREATE TABLE carrierroute (
    id INTEGER PRIMARY KEY NOT NULL,
    carrier INT UNSIGNED DEFAULT 0 NOT NULL,
    domain INT UNSIGNED DEFAULT 0 NOT NULL,
    scan_prefix VARCHAR(64) DEFAULT '' NOT NULL,
    flags INT UNSIGNED DEFAULT 0 NOT NULL,
    mask INT UNSIGNED DEFAULT 0 NOT NULL,
    prob FLOAT DEFAULT 0 NOT NULL,
    strip INT UNSIGNED DEFAULT 0 NOT NULL,
    rewrite_host VARCHAR(128) DEFAULT '' NOT NULL,
    rewrite_prefix VARCHAR(64) DEFAULT '' NOT NULL,
    rewrite_suffix VARCHAR(64) DEFAULT '' NOT NULL,
    description VARCHAR(255) DEFAULT NULL
);
CREATE TABLE carrierfailureroute (
    id INTEGER PRIMARY KEY NOT NULL,
    carrier INT UNSIGNED DEFAULT 0 NOT NULL,
    domain INT UNSIGNED DEFAULT 0 NOT NULL,
    scan_prefix VARCHAR(64) DEFAULT '' NOT NULL,
    host_name VARCHAR(128) DEFAULT '' NOT NULL,
    reply_code VARCHAR(3) DEFAULT '' NOT NULL,
    flags INT UNSIGNED DEFAULT 0 NOT NULL,
    mask INT UNSIGNED DEFAULT 0 NOT NULL,
    next_domain INT UNSIGNED DEFAULT 0 NOT NULL,
    description VARCHAR(255) DEFAULT NULL
);
CREATE TABLE carrier_name (
    id INTEGER PRIMARY KEY NOT NULL,
    carrier VARCHAR(64) DEFAULT NULL
);
CREATE TABLE domain_name (
    id INTEGER PRIMARY KEY NOT NULL,
    domain VARCHAR(64) DEFAULT NULL
);
CREATE TABLE cpl (
    id INTEGER PRIMARY KEY NOT NULL,
    username VARCHAR(64) NOT NULL,
    domain VARCHAR(64) DEFAULT '' NOT NULL,
    cpl_xml TEXT,
    cpl_bin TEXT,
    CONSTRAINT account_idx UNIQUE (username, domain)
);
CREATE TABLE dialplan (
    id INTEGER PRIMARY KEY NOT NULL,
    dpid INT NOT NULL,
    pr INT NOT NULL,
    match_op INT NOT NULL,
    match_exp VARCHAR(64) NOT NULL,
    match_len INT NOT NULL,
    subst_exp VARCHAR(64) NOT NULL,
    repl_exp VARCHAR(256) NOT NULL,
    attrs VARCHAR(32) NOT NULL
);
CREATE TABLE dispatcher (
    id INTEGER PRIMARY KEY NOT NULL,
    setid INT DEFAULT 0 NOT NULL,
    destination VARCHAR(192) DEFAULT '' NOT NULL,
    flags INT DEFAULT 0 NOT NULL,
    priority INT DEFAULT 0 NOT NULL,
    description VARCHAR(64) DEFAULT '' NOT NULL
);
CREATE TABLE domain (
    id INTEGER PRIMARY KEY NOT NULL,
    domain VARCHAR(64) DEFAULT '' NOT NULL,
    last_modified DATETIME DEFAULT '1900-01-01 00:00:01' NOT NULL,
    CONSTRAINT domain_idx UNIQUE (domain)
);
CREATE TABLE domainpolicy (
    id INTEGER PRIMARY KEY NOT NULL,
    rule VARCHAR(255) NOT NULL,
    type VARCHAR(255) NOT NULL,
    att VARCHAR(255),
    val VARCHAR(128),
    description VARCHAR(255) NOT NULL,
    CONSTRAINT rav_idx UNIQUE (rule, att, val)
);
CREATE TABLE grp (
    id INTEGER PRIMARY KEY NOT NULL,
    username VARCHAR(64) DEFAULT '' NOT NULL,
    domain VARCHAR(64) DEFAULT '' NOT NULL,
    grp VARCHAR(64) DEFAULT '' NOT NULL,
    last_modified DATETIME DEFAULT '1900-01-01 00:00:01' NOT NULL,
    CONSTRAINT account_group_idx UNIQUE (username, domain, grp)
);
CREATE TABLE re_grp (
    id INTEGER PRIMARY KEY NOT NULL,
    reg_exp VARCHAR(128) DEFAULT '' NOT NULL,
    group_id INT DEFAULT 0 NOT NULL
);
CREATE TABLE htable (
    id INTEGER PRIMARY KEY NOT NULL,
    key_name VARCHAR(64) DEFAULT '' NOT NULL,
    key_type INT DEFAULT 0 NOT NULL,
    value_type INT DEFAULT 0 NOT NULL,
    key_value VARCHAR(128) DEFAULT '' NOT NULL
);
CREATE TABLE imc_rooms (
    id INTEGER PRIMARY KEY NOT NULL,
    name VARCHAR(64) NOT NULL,
    domain VARCHAR(64) NOT NULL,
    flag INT NOT NULL,
 CONSTRAINT name_domain_idx UNIQUE (name, domain)
);
CREATE TABLE imc_members (
    id INTEGER PRIMARY KEY NOT NULL,
    username VARCHAR(64) NOT NULL,
    domain VARCHAR(64) NOT NULL,
    room VARCHAR(64) NOT NULL,
    flag INT NOT NULL,
    CONSTRAINT account_room_idx UNIQUE (username, domain, room)
);
CREATE TABLE gw (
    id INTEGER PRIMARY KEY NOT NULL,
    lcr_id SMALLINT UNSIGNED NOT NULL,
    gw_name VARCHAR(128) NOT NULL,
    grp_id INT UNSIGNED NOT NULL,
    ip_addr VARCHAR(15) NOT NULL,
    hostname VARCHAR(64),
    port SMALLINT UNSIGNED,
    uri_scheme TINYINT UNSIGNED,
    transport TINYINT UNSIGNED,
    strip TINYINT UNSIGNED,
    tag VARCHAR(16) DEFAULT NULL,
    weight INT UNSIGNED,
    flags INT UNSIGNED DEFAULT 0 NOT NULL,
    defunct INT UNSIGNED DEFAULT NULL,
    CONSTRAINT lcr_id_gw_name_idx UNIQUE (lcr_id, gw_name)
);
CREATE TABLE lcr (
    id INTEGER PRIMARY KEY NOT NULL,
    lcr_id SMALLINT UNSIGNED NOT NULL,
    prefix VARCHAR(16) DEFAULT NULL,
    from_uri VARCHAR(64) DEFAULT NULL,
    grp_id INT UNSIGNED NOT NULL,
    priority TINYINT UNSIGNED NOT NULL
);
CREATE TABLE silo (
    id INTEGER PRIMARY KEY NOT NULL,
    src_addr VARCHAR(128) DEFAULT '' NOT NULL,
    dst_addr VARCHAR(128) DEFAULT '' NOT NULL,
    username VARCHAR(64) DEFAULT '' NOT NULL,
    domain VARCHAR(64) DEFAULT '' NOT NULL,
    inc_time INT DEFAULT 0 NOT NULL,
    exp_time INT DEFAULT 0 NOT NULL,
    snd_time INT DEFAULT 0 NOT NULL,
    ctype VARCHAR(32) DEFAULT 'text/plain' NOT NULL,
    body BLOB,
    extra_hdrs TEXT,
    callid VARCHAR(128) DEFAULT '' NOT NULL,
    status INT DEFAULT 0 NOT NULL
);
CREATE TABLE pdt (
    id INTEGER PRIMARY KEY NOT NULL,
    sdomain VARCHAR(128) NOT NULL,
    prefix VARCHAR(32) NOT NULL,
    domain VARCHAR(128) DEFAULT '' NOT NULL,
    CONSTRAINT sdomain_prefix_idx UNIQUE (sdomain, prefix)
);
CREATE TABLE trusted (
    id INTEGER PRIMARY KEY NOT NULL,
    src_ip VARCHAR(50) NOT NULL,
    proto VARCHAR(4) NOT NULL,
    from_pattern VARCHAR(64) DEFAULT NULL,
    ruri_pattern VARCHAR(64) DEFAULT NULL,
    tag VARCHAR(64),
    priority INTEGER DEFAULT 0 NOT NULL
);
CREATE TABLE address (
    id INTEGER PRIMARY KEY NOT NULL,
    grp SMALLINT UNSIGNED DEFAULT 0 NOT NULL,
    ip_addr VARCHAR(15) NOT NULL,
    mask TINYINT DEFAULT 32 NOT NULL,
    port SMALLINT UNSIGNED DEFAULT 0 NOT NULL
);
CREATE TABLE purplemap (
    id INTEGER PRIMARY KEY NOT NULL,
    sip_user VARCHAR(128) NOT NULL,
    ext_user VARCHAR(128) NOT NULL,
    ext_prot VARCHAR(16) NOT NULL,
    ext_pass VARCHAR(64)
);
CREATE TABLE aliases (
    id INTEGER PRIMARY KEY NOT NULL,
    ruid VARCHAR(64) DEFAULT '' NOT NULL,
    username VARCHAR(64) DEFAULT '' NOT NULL,
    domain VARCHAR(64) DEFAULT NULL,
    contact VARCHAR(255) DEFAULT '' NOT NULL,
    received VARCHAR(128) DEFAULT NULL,
    path VARCHAR(512) DEFAULT NULL,
    expires DATETIME DEFAULT '2030-05-28 21:32:15' NOT NULL,
    q FLOAT(10,2) DEFAULT 1.0 NOT NULL,
    callid VARCHAR(255) DEFAULT 'Default-Call-ID' NOT NULL,
    cseq INT DEFAULT 13 NOT NULL,
    last_modified DATETIME DEFAULT '2000-01-01 00:00:01' NOT NULL,
    flags INT DEFAULT 0 NOT NULL,
    cflags INT DEFAULT 0 NOT NULL,
    user_agent VARCHAR(255) DEFAULT '' NOT NULL,
    socket VARCHAR(64) DEFAULT NULL,
    methods INT DEFAULT NULL,
    instance VARCHAR(255) DEFAULT NULL,
    reg_id INT DEFAULT 0 NOT NULL,
    server_id INT DEFAULT 0 NOT NULL,
    connection_id INT DEFAULT 0 NOT NULL,
    keepalive INT DEFAULT 0 NOT NULL,
    partition INT DEFAULT 0 NOT NULL,
    CONSTRAINT aliases_ruid_idx UNIQUE (ruid)
);
CREATE TABLE rls_presentity (
    id INTEGER PRIMARY KEY NOT NULL,
    rlsubs_did VARCHAR(255) NOT NULL,
    resource_uri VARCHAR(128) NOT NULL,
    content_type VARCHAR(64) NOT NULL,
    presence_state BLOB NOT NULL,
    expires INT NOT NULL,
    updated INT NOT NULL,
    auth_state INT NOT NULL,
    reason VARCHAR(64) NOT NULL,
    CONSTRAINT rls_presentity_idx UNIQUE (rlsubs_did, resource_uri)
);
CREATE TABLE rls_watchers (
    id INTEGER PRIMARY KEY NOT NULL,
    presentity_uri VARCHAR(128) NOT NULL,
    to_user VARCHAR(64) NOT NULL,
    to_domain VARCHAR(64) NOT NULL,
    watcher_username VARCHAR(64) NOT NULL,
    watcher_domain VARCHAR(64) NOT NULL,
    event VARCHAR(64) DEFAULT 'presence' NOT NULL,
    event_id VARCHAR(64),
    to_tag VARCHAR(64) NOT NULL,
    from_tag VARCHAR(64) NOT NULL,
    callid VARCHAR(64) NOT NULL,
    local_cseq INT NOT NULL,
    remote_cseq INT NOT NULL,
    contact VARCHAR(64) NOT NULL,
    record_route TEXT,
    expires INT NOT NULL,
    status INT DEFAULT 2 NOT NULL,
    reason VARCHAR(64) NOT NULL,
    version INT DEFAULT 0 NOT NULL,
    socket_info VARCHAR(64) NOT NULL,
    local_contact VARCHAR(128) NOT NULL,
    CONSTRAINT rls_watcher_idx UNIQUE (presentity_uri, callid, to_tag, from_tag)
);
CREATE TABLE sip_trace (
    id INTEGER PRIMARY KEY NOT NULL,
    time_stamp TIMESTAMP WITHOUT TIME ZONE DEFAULT '2000-01-01 00:00:01' NOT NULL,
    time_us INTEGER DEFAULT 0 NOT NULL,
    callid VARCHAR(255) DEFAULT '' NOT NULL,
    traced_user VARCHAR(128) DEFAULT '' NOT NULL,
    msg TEXT NOT NULL,
    method VARCHAR(50) DEFAULT '' NOT NULL,
    status VARCHAR(128) DEFAULT '' NOT NULL,
    fromip VARCHAR(50) DEFAULT '' NOT NULL,
    toip VARCHAR(50) DEFAULT '' NOT NULL,
    fromtag VARCHAR(64) DEFAULT '' NOT NULL,
    totag VARCHAR(64) DEFAULT '' NOT NULL,
    direction VARCHAR(4) DEFAULT '' NOT NULL
);
CREATE TABLE speed_dial (
    id INTEGER PRIMARY KEY NOT NULL,
    username VARCHAR(64) DEFAULT '' NOT NULL,
    domain VARCHAR(64) DEFAULT '' NOT NULL,
    sd_username VARCHAR(64) DEFAULT '' NOT NULL,
    sd_domain VARCHAR(64) DEFAULT '' NOT NULL,
    new_uri VARCHAR(128) DEFAULT '' NOT NULL,
    fname VARCHAR(64) DEFAULT '' NOT NULL,
    lname VARCHAR(64) DEFAULT '' NOT NULL,
    description VARCHAR(64) DEFAULT '' NOT NULL,
    CONSTRAINT speed_dial_idx UNIQUE (username, domain, sd_domain, sd_username)
);
CREATE TABLE uri (
    id INTEGER PRIMARY KEY NOT NULL,
    username VARCHAR(64) DEFAULT '' NOT NULL,
    domain VARCHAR(64) DEFAULT '' NOT NULL,
    uri_user VARCHAR(64) DEFAULT '' NOT NULL,
    last_modified DATETIME DEFAULT '1900-01-01 00:00:01' NOT NULL,
    CONSTRAINT account_idx UNIQUE (username, domain, uri_user)
);
CREATE TABLE userblacklist (
    id INTEGER PRIMARY KEY NOT NULL,
    username VARCHAR(64) DEFAULT '' NOT NULL,
    domain VARCHAR(64) DEFAULT '' NOT NULL,
    prefix VARCHAR(64) DEFAULT '' NOT NULL,
    whitelist TINYINT DEFAULT 0 NOT NULL
);
CREATE TABLE globalblacklist (
    id INTEGER PRIMARY KEY NOT NULL,
    prefix VARCHAR(64) DEFAULT '' NOT NULL,
    whitelist TINYINT DEFAULT 0 NOT NULL,
    description VARCHAR(255) DEFAULT NULL
);
CREATE TABLE pua (
    id INTEGER PRIMARY KEY NOT NULL,
    pres_uri VARCHAR(128) NOT NULL,
    pres_id VARCHAR(64) NOT NULL,
    event INT NOT NULL,
    expires INT NOT NULL,
    desired_expires INT NOT NULL,
    flag INT NOT NULL,
    etag VARCHAR(64) NOT NULL,
    tuple_id VARCHAR(64),
    watcher_uri VARCHAR(128) NOT NULL,
    call_id VARCHAR(64) NOT NULL,
    to_tag VARCHAR(64) NOT NULL,
    from_tag VARCHAR(64) NOT NULL,
    cseq INT NOT NULL,
    record_route TEXT,
    contact VARCHAR(128),
    remote_contact VARCHAR(128),
    version INTEGER,
    extra_headers TEXT
);
CREATE TABLE dialog (
    id INTEGER PRIMARY KEY NOT NULL,
    hash_entry INT UNSIGNED NOT NULL,
    hash_id INT UNSIGNED NOT NULL,
    callid VARCHAR(255) NOT NULL,
    from_uri VARCHAR(128) NOT NULL,
    from_tag VARCHAR(64) NOT NULL,
    to_uri VARCHAR(128) NOT NULL,
    to_tag VARCHAR(64) NOT NULL,
    caller_cseq VARCHAR(7) NOT NULL,
    callee_cseq VARCHAR(7) NOT NULL,
    caller_route_set VARCHAR(512),
    callee_route_set VARCHAR(512),
    caller_contact VARCHAR(128) NOT NULL,
    callee_contact VARCHAR(128) NOT NULL,
    caller_sock VARCHAR(64) NOT NULL,
    callee_sock VARCHAR(64) NOT NULL,
    state INT UNSIGNED NOT NULL,
    start_time INT UNSIGNED NOT NULL,
    timeout INT UNSIGNED DEFAULT 0 NOT NULL,
    sflags INT UNSIGNED DEFAULT 0 NOT NULL,
    toroute INT UNSIGNED DEFAULT 0 NOT NULL,
    req_uri VARCHAR(128)
);
CREATE INDEX acc_callid_idx ON acc (callid);
CREATE INDEX mc_callid_idx ON missed_calls (callid);
CREATE INDEX bdaliases_target_idx ON dbaliases (username, domain);
CREATE INDEX subscriber_username_idx ON subscriber (username);
CREATE INDEX up_ua_idx ON usr_preferences (uuid, attribute);
CREATE INDEX up_uda_idx ON usr_preferences (username, domain, attribute);
CREATE INDEX dp_rule_idx ON domainpolicy (rule);
CREATE INDEX re_group_idx ON re_grp (group_id);
CREATE INDEX lcr_id_idx ON lcr (lcr_id);
CREATE INDEX silo_account_idx ON silo (username, domain);
CREATE INDEX trusted_peer_idx ON trusted (src_ip);
CREATE INDEX aliases_account_contact_idx ON aliases (username, domain, contact);
CREATE INDEX aliases_expires_idx ON aliases (expires);
CREATE INDEX updated_idx ON rls_presentity (updated);
CREATE INDEX sip_trace_traced_user_idx ON sip_trace (traced_user);
CREATE INDEX sip_trace_date_idx ON sip_trace (time_stamp);
CREATE INDEX sip_trace_fromip_idx ON sip_trace (fromip);
CREATE INDEX sip_trace_callid_idx ON sip_trace (callid);
CREATE INDEX userblacklist_idx ON userblacklist (username, domain, prefix);
CREATE INDEX globalblacklist_idx ON globalblacklist (prefix);
CREATE INDEX dialog_hash_idx ON dialog (hash_entry, hash_id);
COMMIT;
